## umoci 0.4.0+dfsg

=== Makefile ===
# umoci: Umoci Modifies Open Containers' Images
# Copyright (C) 2016, 2017, 2018 SUSE LLC.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Use bash, so that we can do process substitution.
SHELL = /bin/bash

# Go tools.
GO ?= go
GO_MD2MAN ?= go-md2man

# Set up the ... lovely ... GOPATH hacks.
PROJECT := github.com/openSUSE/umoci
CMD := ${PROJECT}/cmd/umoci

# We use Docker because Go is just horrific to deal with.
UMOCI_IMAGE := umoci_dev
DOCKER_RUN := docker run --rm -it --security-opt apparmor:unconfined --security-opt label:disable -v ${PWD}:/go/src/${PROJECT}

# Output directory.
BUILD_DIR ?= .

# Release information.
GPG_KEYID ?=

# Version information.
VERSION := $(shell cat ./VERSION)
COMMIT_NO := $(shell git rev-parse HEAD 2> /dev/null || true)
COMMIT := $(if $(shell git status --porcelain --untracked-files=no),"${COMMIT_NO}-dirty","${COMMIT_NO}")

BUILD_FLAGS ?=
DYN_BUILD_FLAGS := $(BUILD_FLAGS) -buildmode=pie -ldflags "-s -w -X main.gitCommit=${COMMIT} -X main.version=${VERSION}" -tags "$(BUILDTAGS)"
STATIC_BUILD_FLAGS := $(BUILD_FLAGS) -ldflags "-s -w -extldflags '-static' -X main.gitCommit=${COMMIT} -X main.version=${VERSION}" -tags "$(BUILDTAGS)"

.DEFAULT: umoci

GO_SRC = $(shell find . -name \*.go)

# NOTE: If you change these make sure you also update local-validate-build.

umoci: $(GO_SRC)
	$(GO) build ${DYN_BUILD_FLAGS} -o $(BUILD_DIR)/$@ ${CMD}

umoci.static: $(GO_SRC)
	env CGO_ENABLED=0 $(GO) build ${STATIC_BUILD_FLAGS} -o $(BUILD_DIR)/$@ ${CMD}

umoci.cover: $(GO_SRC)
	$(GO) test -c -cover -covermode=count -coverpkg=./... ${DYN_BUILD_FLAGS} -o $(BUILD_DIR)/$@ ${CMD}

.PHONY: release
release:
	hack/release.sh -S "$(GPG_KEYID)" -r release/$(VERSION) -v $(VERSION)

.PHONY: install
install: $(GO_SRC)
	$(GO) install -v ${DYN_BUILD_FLAGS} ${CMD}

.PHONY: install.static
install.static: $(GO_SRC)
	$(GO) install -v ${STATIC_BUILD_FLAGS} ${CMD}

.PHONY: update-deps
update-deps:
	hack/vendor.sh

.PHONY: clean
clean:
	rm -f umoci umoci.static
	rm -f $(MANPAGES)

.PHONY: validate
validate: umociimage
	$(DOCKER_RUN) $(UMOCI_IMAGE) make local-validate

.PHONY: local-validate
local-validate: local-validate-git local-validate-go local-validate-reproducible local-validate-build

# TODO: Remove the special-case ignored system/* warnings.
.PHONY: local-validate-go
local-validate-go:
	@which gofmt    >/dev/null 2>/dev/null || (echo "ERROR: gofmt not found." && false)
	test -z "$$(gofmt -s -l . | grep -vE '^vendor/|^third_party/' | tee /dev/stderr)"
	@which golint   >/dev/null 2>/dev/null || (echo "ERROR: golint not found." && false)
	test -z "$$(golint $(PROJECT)/... | grep -vE '/vendor/|/third_party/' | tee /dev/stderr)"
	@go doc cmd/vet >/dev/null 2>/dev/null || (echo "ERROR: go vet not found." && false)
	test -z "$$($(GO) vet $$($(GO) list $(PROJECT)/... | grep -vE '/vendor/|/third_party/') 2>&1 | tee /dev/stderr)"

EPOCH_COMMIT ?= 97ecdbd53dcb72b7a0d62196df281f131dc9eb2f
.PHONY: local-validate-git
local-validate-git:
	@which git-validation > /dev/null 2>/dev/null || (echo "ERROR: git-validation not found." && false)
ifdef TRAVIS_COMMIT_RANGE
	git-validation -q -run DCO,short-subject
else
	git-validation -q -run DCO,short-subject -range $(EPOCH_COMMIT)..HEAD
endif

# Make sure that our builds are reproducible even if you wait between them and
# the modified time of the files is different.
.PHONY: local-validate-reproducible
local-validate-reproducible:
	mkdir -p .tmp-validate
	make -B umoci && cp umoci .tmp-validate/umoci.a
	@echo sleep 10s
	@sleep 10s && touch $(GO_SRC)
	make -B umoci && cp umoci .tmp-validate/umoci.b
	diff -s .tmp-validate/umoci.{a,b}
	sha256sum .tmp-validate/umoci.{a,b}
	rm -r .tmp-validate/umoci.{a,b}

.PHONY: local-validate-build
local-validate-build:
	$(GO) build ${DYN_BUILD_FLAGS} -o /dev/null ${CMD}
	env CGO_ENABLED=0 $(GO) build ${STATIC_BUILD_FLAGS} -o /dev/null ${CMD}
	$(GO) test -run nothing ${DYN_BUILD_FLAGS} $(PROJECT)/...

MANPAGES_MD := $(wildcard doc/man/*.md)
MANPAGES    := $(MANPAGES_MD:%.md=%)

doc/man/%.1: doc/man/%.1.md
	$(GO_MD2MAN) -in $< -out $@

.PHONY: doc
doc: $(MANPAGES)

# Used for tests.
DOCKER_IMAGE :=opensuse/amd64:tumbleweed

.PHONY: umociimage
umociimage:
	docker build -t $(UMOCI_IMAGE) --build-arg DOCKER_IMAGE=$(DOCKER_IMAGE) .

ifndef COVERAGE
COVERAGE := $(shell mktemp --dry-run umoci.cov.XXXXXX)
endif

.PHONY: test-unit
test-unit: umociimage
	touch $(COVERAGE) && chmod a+rw $(COVERAGE)
	$(DOCKER_RUN) -e COVERAGE=$(COVERAGE) --cap-add=SYS_ADMIN $(UMOCI_IMAGE) make local-test-unit
	$(DOCKER_RUN) -e COVERAGE=$(COVERAGE) -u 1000:1000 --cap-drop=all $(UMOCI_IMAGE) make local-test-unit

.PHONY: local-test-unit
local-test-unit:
	GO=$(GO) COVER=1 hack/test-unit.sh

.PHONY: test-integration
test-integration: umociimage
	touch $(COVERAGE) && chmod a+rw $(COVERAGE)
	$(DOCKER_RUN) -e COVERAGE=$(COVERAGE) $(UMOCI_IMAGE) make TESTS="${TESTS}" local-test-integration
	$(DOCKER_RUN) -e COVERAGE=$(COVERAGE) -u 1000:1000 --cap-drop=all $(UMOCI_IMAGE) make TESTS="${TESTS}" local-test-integration

.PHONY: local-test-integration
local-test-integration: umoci.cover
	TESTS="${TESTS}" COVER=1 hack/test-integration.sh

shell: umociimage
	$(DOCKER_RUN) $(UMOCI_IMAGE) bash

.PHONY: ci
ci: umoci umoci.cover doc local-validate test-unit test-integration
	hack/ci-coverage.sh $(COVERAGE)

=== debian/changelog ===
umoci (0.4.0+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #902024).

 -- Dmitry Smirnov <onlyjob@debian.org>  Fri, 06 Jul 2018 12:51:45 +1000

=== debian/control ===
Source: umoci
Section: devel
Priority: optional
Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Dmitry Smirnov <onlyjob@debian.org>
Build-Depends: debhelper (>= 11~)
              ,dh-golang
              ,golang-any
    ,golang-github-apex-log-dev
    ,golang-github-cyphar-filepath-securejoin-dev
    ,golang-github-docker-go-units-dev
    ,golang-github-opencontainers-go-digest-dev
    ,golang-github-opencontainers-image-spec-dev
    ,golang-github-opencontainers-specs-dev
    ,golang-github-pkg-errors-dev
    ,golang-github-urfave-cli-dev
    ,golang-github-vbatts-go-mtree-dev
    ,golang-gocapability-dev
    ,golang-golang-x-net-dev
    ,golang-golang-x-sys-dev
    ,golang-goprotobuf-dev
    ,go-md2man
Standards-Version: 4.1.4
Homepage: https://github.com/openSUSE/umoci
Vcs-Browser: https://salsa.debian.org/go-team/packages/umoci
Vcs-Git: https://salsa.debian.org/go-team/packages/umoci.git
XS-Go-Import-Path: github.com/openSUSE/umoci
Testsuite: autopkgtest-pkg-go

Package: umoci
Architecture: any
Built-Using: ${misc:Built-Using}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Open Container Images manipulation tool
 umoci creates and modifies Open Container images.
 See the official website (https://umo.ci/) for more accessible
 documentation about how to use umoci.
 .
 umoci intends to be a complete manipulation tool for OCI images
 (https://github.com/opencontainers/image-spec).  In particular, it should
 be seen as a more end-user-focused version of the oci-image-tools provided
 by the OCI (https://github.com/opencontainers/image-tools). The hope is
 that all of this tooling will eventually be merged with the upstream
 repository, so that it is always kept up-to-date by the Open Container
 Initiative community.
 .
 umoci provides tooling that can abstract all of the internals of the OCI
 specification into a single CLI interface.

=== debian/rules ===
#!/usr/bin/make -f

## Depends += gogoprotobuf golang-goprotobuf-dev
export DH_GOLANG_GO_GENERATE := 1

%:
	dh $@ --buildsystem=golang --with=golang

override_dh_auto_build:
	COMMIT=1 COMMIT_NO=1 $(MAKE) doc
	dh_auto_build

override_dh_clean:
	dh_clean
	## Remove Files-Excluded (when built from checkout or non-DFSG tarball):
	$(RM) -rv `perl -0nE 'say $$1 if m{^Files\-Excluded\:\s*(.*?)(?:\n\n|Files:|Comment:)}sm;' debian/copyright`
	-find vendor -mindepth 1 -type d -empty -delete -printf 'removed %p\n'
	-find . -type f -name '*.generated.go' -delete -printf 'removed %p\n'     ## delete .generated.go files
	-find . -type f -name '*.pb.go' -delete -printf 'removed %p\n'            ## delete generated .pb.go files

override_dh_auto_install:
	dh_auto_install -- --no-source

## umoci 0.4.4+dfsg

=== Makefile ===
--- 
+++ 
@@ -19,6 +19,7 @@
 # Go tools.
 GO ?= go
 GO_MD2MAN ?= go-md2man
+export GO111MODULE=off
 
 # Set up the ... lovely ... GOPATH hacks.
 PROJECT := github.com/openSUSE/umoci
@@ -39,9 +40,21 @@
 COMMIT_NO := $(shell git rev-parse HEAD 2> /dev/null || true)
 COMMIT := $(if $(shell git status --porcelain --untracked-files=no),"${COMMIT_NO}-dirty","${COMMIT_NO}")
 
+# Basic build flags.
 BUILD_FLAGS ?=
-DYN_BUILD_FLAGS := $(BUILD_FLAGS) -buildmode=pie -ldflags "-s -w -X main.gitCommit=${COMMIT} -X main.version=${VERSION}" -tags "$(BUILDTAGS)"
-STATIC_BUILD_FLAGS := $(BUILD_FLAGS) -ldflags "-s -w -extldflags '-static' -X main.gitCommit=${COMMIT} -X main.version=${VERSION}" -tags "$(BUILDTAGS)"
+BASE_FLAGS := ${BUILD_FLAGS} -tags "${BUILDTAGS}"
+BASE_LDFLAGS := -s -w -X main.gitCommit=${COMMIT} -X main.version=${VERSION}
+
+# Specific build flags for build type.
+DYN_BUILD_FLAGS := ${BASE_FLAGS} -buildmode=pie -ldflags "${BASE_LDFLAGS}"
+TEST_BUILD_FLAGS := ${BASE_FLAGS} -buildmode=pie -ldflags "${BASE_LDFLAGS} -X ${PROJECT}/pkg/testutils.binaryType=test"
+STATIC_BUILD_FLAGS := ${BASE_FLAGS} -ldflags "${BASE_LDFLAGS} -extldflags '-static'"
+
+# Installation directories.
+DESTDIR ?=
+PREFIX ?=/usr
+BINDIR ?=$(PREFIX)/bin
+MANDIR ?=$(PREFIX)/share/man
 
 .DEFAULT: umoci
 
@@ -56,27 +69,30 @@
 	env CGO_ENABLED=0 $(GO) build ${STATIC_BUILD_FLAGS} -o $(BUILD_DIR)/$@ ${CMD}
 
 umoci.cover: $(GO_SRC)
-	$(GO) test -c -cover -covermode=count -coverpkg=./... ${DYN_BUILD_FLAGS} -o $(BUILD_DIR)/$@ ${CMD}
+	$(GO) test -c -cover -covermode=count -coverpkg=./... ${TEST_BUILD_FLAGS} -o $(BUILD_DIR)/$@ ${CMD}
 
 .PHONY: release
 release:
 	hack/release.sh -S "$(GPG_KEYID)" -r release/$(VERSION) -v $(VERSION)
 
 .PHONY: install
-install: $(GO_SRC)
-	$(GO) install -v ${DYN_BUILD_FLAGS} ${CMD}
+install: umoci doc
+	install -D -m0755 umoci $(DESTDIR)/$(BINDIR)/umoci
+	-for man in $(MANPAGES); do \
+		filename="$$(basename -- "$$man")"; \
+		target="$(DESTDIR)/$(MANDIR)/man$${filename##*.}/$$filename"; \
+		install -D -m0644 "$$man" "$$target"; \
+		gzip -9f "$$target"; \
+	 done
 
-.PHONY: install.static
-install.static: $(GO_SRC)
-	$(GO) install -v ${STATIC_BUILD_FLAGS} ${CMD}
-
-.PHONY: update-deps
-update-deps:
-	hack/vendor.sh
+.PHONY: uninstall
+uninstall:
+	rm -f $(DESTDIR)/$(BINDIR)/umoci
+	-rm -f $(DESTDIR)/$(MANDIR)/man*/umoci*
 
 .PHONY: clean
 clean:
-	rm -f umoci umoci.static
+	rm -f umoci umoci.static umoci.cov*
 	rm -f $(MANPAGES)
 
 .PHONY: validate
@@ -89,17 +105,20 @@
 # TODO: Remove the special-case ignored system/* warnings.
 .PHONY: local-validate-go
 local-validate-go:
-	@which gofmt    >/dev/null 2>/dev/null || (echo "ERROR: gofmt not found." && false)
+	@type gofmt     >/dev/null 2>/dev/null || (echo "ERROR: gofmt not found." && false)
 	test -z "$$(gofmt -s -l . | grep -vE '^vendor/|^third_party/' | tee /dev/stderr)"
-	@which golint   >/dev/null 2>/dev/null || (echo "ERROR: golint not found." && false)
+	@type golint    >/dev/null 2>/dev/null || (echo "ERROR: golint not found." && false)
 	test -z "$$(golint $(PROJECT)/... | grep -vE '/vendor/|/third_party/' | tee /dev/stderr)"
 	@go doc cmd/vet >/dev/null 2>/dev/null || (echo "ERROR: go vet not found." && false)
 	test -z "$$($(GO) vet $$($(GO) list $(PROJECT)/... | grep -vE '/vendor/|/third_party/') 2>&1 | tee /dev/stderr)"
+	@type gosec     >/dev/null 2>/dev/null || (echo "ERROR: gosec not found." && false)
+	test -z "$$(gosec -quiet -exclude=G301,G302,G304 $$GOPATH/$(PROJECT)/... | tee /dev/stderr)"
+	./hack/test-vendor.sh
 
 EPOCH_COMMIT ?= 97ecdbd53dcb72b7a0d62196df281f131dc9eb2f
 .PHONY: local-validate-git
 local-validate-git:
-	@which git-validation > /dev/null 2>/dev/null || (echo "ERROR: git-validation not found." && false)
+	@type git-validation > /dev/null 2>/dev/null || (echo "ERROR: git-validation not found." && false)
 ifdef TRAVIS_COMMIT_RANGE
 	git-validation -q -run DCO,short-subject
 else

=== debian/changelog ===
umoci (0.4.4+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 02 Feb 2019 14:08:05 +1100

umoci (0.4.3+dfsg-1) unstable; urgency=medium

  * New upstream release
    + golang-github-fatih-color-dev (Closes: #917595)
    + golang-github-klauspost-pgzip-dev
    + golang-github-mattn-go-colorable-dev
    + golang-github-opencontainers-runtime-tools-dev
  * Standards-Version: 4.3.0

 -- Dmitry Smirnov <onlyjob@debian.org>  Mon, 28 Jan 2019 00:14:27 +1100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 Source: umoci
 Section: devel
 Priority: optional
+Standards-Version: 4.3.0
 Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
 Uploaders: Dmitry Smirnov <onlyjob@debian.org>
 Build-Depends: debhelper (>= 11~)
@@ -9,8 +10,12 @@
     ,golang-github-apex-log-dev
     ,golang-github-cyphar-filepath-securejoin-dev
     ,golang-github-docker-go-units-dev
+    ,golang-github-fatih-color-dev
+    ,golang-github-klauspost-pgzip-dev
+    ,golang-github-mattn-go-colorable-dev
     ,golang-github-opencontainers-go-digest-dev
     ,golang-github-opencontainers-image-spec-dev
+    ,golang-github-opencontainers-runtime-tools-dev
     ,golang-github-opencontainers-specs-dev
     ,golang-github-pkg-errors-dev
     ,golang-github-urfave-cli-dev
@@ -20,7 +25,6 @@
     ,golang-golang-x-sys-dev
     ,golang-goprotobuf-dev
     ,go-md2man
-Standards-Version: 4.1.4
 Homepage: https://github.com/openSUSE/umoci
 Vcs-Browser: https://salsa.debian.org/go-team/packages/umoci
 Vcs-Git: https://salsa.debian.org/go-team/packages/umoci.git

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,11 @@
 
 override_dh_auto_build:
 	COMMIT=1 COMMIT_NO=1 $(MAKE) doc
-	dh_auto_build
+	
+	## `go generate` must run in "vendor":
+	DH_GOPKG="github.com/openSUSE/umoci/vendor"    dh_auto_build -v
+	
+	dh_auto_build -v
 
 override_dh_clean:
 	dh_clean

## umoci 0.4.5+dfsg

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # umoci: Umoci Modifies Open Containers' Images
-# Copyright (C) 2016, 2017, 2018 SUSE LLC.
+# Copyright (C) 2016-2019 SUSE LLC.
 #
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
@@ -73,7 +73,7 @@
 
 .PHONY: release
 release:
-	hack/release.sh -S "$(GPG_KEYID)" -r release/$(VERSION) -v $(VERSION)
+	hack/release.sh -v $(VERSION) -S "$(GPG_KEYID)"
 
 .PHONY: install
 install: umoci doc
@@ -100,7 +100,7 @@
 	$(DOCKER_RUN) $(UMOCI_IMAGE) make local-validate
 
 .PHONY: local-validate
-local-validate: local-validate-git local-validate-go local-validate-reproducible local-validate-build
+local-validate: local-validate-go local-validate-reproducible local-validate-build
 
 # TODO: Remove the special-case ignored system/* warnings.
 .PHONY: local-validate-go
@@ -114,16 +114,6 @@
 	@type gosec     >/dev/null 2>/dev/null || (echo "ERROR: gosec not found." && false)
 	test -z "$$(gosec -quiet -exclude=G301,G302,G304 $$GOPATH/$(PROJECT)/... | tee /dev/stderr)"
 	./hack/test-vendor.sh
-
-EPOCH_COMMIT ?= 97ecdbd53dcb72b7a0d62196df281f131dc9eb2f
-.PHONY: local-validate-git
-local-validate-git:
-	@type git-validation > /dev/null 2>/dev/null || (echo "ERROR: git-validation not found." && false)
-ifdef TRAVIS_COMMIT_RANGE
-	git-validation -q -run DCO,short-subject
-else
-	git-validation -q -run DCO,short-subject -range $(EPOCH_COMMIT)..HEAD
-endif
 
 # Make sure that our builds are reproducible even if you wait between them and
 # the modified time of the files is different.
@@ -144,14 +134,18 @@
 	env CGO_ENABLED=0 $(GO) build ${STATIC_BUILD_FLAGS} -o /dev/null ${CMD}
 	$(GO) test -run nothing ${DYN_BUILD_FLAGS} $(PROJECT)/...
 
+.PHONY: doc
+doc: umociimage
+	$(DOCKER_RUN) $(UMOCI_IMAGE) make local-doc
+
 MANPAGES_MD := $(wildcard doc/man/*.md)
 MANPAGES    := $(MANPAGES_MD:%.md=%)
 
 doc/man/%.1: doc/man/%.1.md
 	$(GO_MD2MAN) -in $< -out $@
 
-.PHONY: doc
-doc: $(MANPAGES)
+.PHONY: local-doc
+local-doc: $(MANPAGES)
 
 # Used for tests.
 DOCKER_IMAGE :=opensuse/amd64:tumbleweed
@@ -188,5 +182,5 @@
 	$(DOCKER_RUN) $(UMOCI_IMAGE) bash
 
 .PHONY: ci
-ci: umoci umoci.cover doc local-validate test-unit test-integration
+ci: umoci umoci.cover doc validate test-unit test-integration
 	hack/ci-coverage.sh $(COVERAGE)

=== debian/changelog ===
umoci (0.4.5+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 08 Dec 2019 10:08:07 +1100

umoci (0.4.4+dfsg-5) unstable; urgency=medium

  * Removed "autopkgtest-pkg-go" due to #944271.

 -- Dmitry Smirnov <onlyjob@debian.org>  Fri, 15 Nov 2019 20:40:59 +1100

umoci (0.4.4+dfsg-4) unstable; urgency=medium

  * Different way to run `go generate` in "vendor" (Closes: #943891).

 -- Dmitry Smirnov <onlyjob@debian.org>  Tue, 05 Nov 2019 14:29:09 +1100

umoci (0.4.4+dfsg-3) unstable; urgency=medium

  * dev: provide "api*" files.

 -- Dmitry Smirnov <onlyjob@debian.org>  Mon, 14 Oct 2019 14:57:52 +1100

umoci (0.4.4+dfsg-2) unstable; urgency=medium

  * Introduced -dev package as required by "singularity-container".
  * Standards-Version: 4.4.1.

 -- Dmitry Smirnov <onlyjob@debian.org>  Tue, 08 Oct 2019 22:53:00 +1100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: umoci
 Section: devel
 Priority: optional
-Standards-Version: 4.3.0
+Standards-Version: 4.4.1
 Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
 Uploaders: Dmitry Smirnov <onlyjob@debian.org>
 Build-Depends: debhelper (>= 11~)
@@ -29,7 +29,6 @@
 Vcs-Browser: https://salsa.debian.org/go-team/packages/umoci
 Vcs-Git: https://salsa.debian.org/go-team/packages/umoci.git
 XS-Go-Import-Path: github.com/openSUSE/umoci
-Testsuite: autopkgtest-pkg-go
 
 Package: umoci
 Architecture: any
@@ -51,3 +50,29 @@
  .
  umoci provides tooling that can abstract all of the internals of the OCI
  specification into a single CLI interface.
+
+Package: golang-github-opensuse-umoci-dev
+Architecture: all
+Depends: ${misc:Depends}
+    ,golang-github-apex-log-dev
+    ,golang-github-cyphar-filepath-securejoin-dev
+    ,golang-github-klauspost-pgzip-dev
+    ,golang-github-opencontainers-go-digest-dev
+    ,golang-github-opencontainers-image-spec-dev
+    ,golang-github-vbatts-go-mtree-dev
+    ,golang-golang-x-net-dev
+    ,golang-goprotobuf-dev
+Description: umoci development files
+ umoci creates and modifies Open Container images.
+ See the official website (https://umo.ci/) for more accessible
+ documentation about how to use umoci.
+ .
+ umoci intends to be a complete manipulation tool for OCI images
+ (https://github.com/opencontainers/image-spec).  In particular, it should
+ be seen as a more end-user-focused version of the oci-image-tools provided
+ by the OCI (https://github.com/opencontainers/image-tools). The hope is
+ that all of this tooling will eventually be merged with the upstream
+ repository, so that it is always kept up-to-date by the Open Container
+ Initiative community.
+ .
+ This package provides Golang sources for the umoci API.

=== debian/rules ===
--- 
+++ 
@@ -4,13 +4,14 @@
 export DH_GOLANG_GO_GENERATE := 1
 
 %:
-	dh $@ --buildsystem=golang --with=golang
+	dh $@ --buildsystem=golang --with=golang --builddirectory=_build
 
 override_dh_auto_build:
-	COMMIT=1 COMMIT_NO=1 $(MAKE) doc
+	COMMIT=1 COMMIT_NO=1 $(MAKE) local-doc
 	
-	## `go generate` must run in "vendor":
-	DH_GOPKG="github.com/openSUSE/umoci/vendor"    dh_auto_build -v
+## `go generate` sub-vendored component(s):
+	cd _build/src/github.com/openSUSE/umoci/vendor/ \
+	&& GO111MODULE=off go generate -v -x ./...
 	
 	dh_auto_build -v

=== debian/watch ===
# uscan(1) configuration file.
version=4

opts="\
pgpmode=none,\
repack,compression=xz,repacksuffix=+dfsg,\
dversionmangle=s{[+~]dfsg\d*}{},\
" https://github.com/openSUSE/umoci/releases \
  .*/archive/v?(\d[\d\.]+)\.tar\.gz

## umoci 0.4.6+ds

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # umoci: Umoci Modifies Open Containers' Images
-# Copyright (C) 2016-2019 SUSE LLC.
+# Copyright (C) 2016-2020 SUSE LLC
 #
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
@@ -19,15 +19,33 @@
 # Go tools.
 GO ?= go
 GO_MD2MAN ?= go-md2man
-export GO111MODULE=off
+export GO111MODULE=on
 
 # Set up the ... lovely ... GOPATH hacks.
-PROJECT := github.com/openSUSE/umoci
+PROJECT := github.com/opencontainers/umoci
 CMD := ${PROJECT}/cmd/umoci
 
 # We use Docker because Go is just horrific to deal with.
 UMOCI_IMAGE := umoci_dev
-DOCKER_RUN := docker run --rm -it --security-opt apparmor:unconfined --security-opt label:disable -v ${PWD}:/go/src/${PROJECT}
+
+# TODO: We should test umoci with all of the security options disabled so that
+#       we can make sure umoci inside containers works fine (all of these
+#       security options are necessary for the test code to run, not umoci
+#       itself). The AppArmor/SELinux settings are needed because of the
+#       mount-related tests, and the seccomp/systempaths settings are required
+#       for the runc tests for rootless containers.
+# XXX: Ideally we'd use --security-opt systempaths=unconfined, but the version
+#      of Docker in Travis-CI doesn't support that. Bind-mounting the host's
+#      proc into the container is more dangerous but has the same effect on the
+#      in-kernel mnt_too_revealing() checks and works on old Docker.
+DOCKER_RUN          := docker run --rm -it \
+                                  -v ${PWD}:/go/src/${PROJECT} \
+                                  --security-opt seccomp=unconfined \
+                                  --security-opt apparmor=unconfined \
+                                  --security-opt label=disable \
+                                  -v /proc:/tmp/.HOTFIX-stashed-proc
+DOCKER_ROOTPRIV_RUN := $(DOCKER_RUN) --privileged --cap-add=SYS_ADMIN
+DOCKER_ROOTLESS_RUN := $(DOCKER_RUN) -u 1000:1000 --cap-drop=all
 
 # Output directory.
 BUILD_DIR ?= .
@@ -58,7 +76,7 @@
 
 .DEFAULT: umoci
 
-GO_SRC = $(shell find . -name \*.go)
+GO_SRC = $(shell find . -type f -name '*.go')
 
 # NOTE: If you change these make sure you also update local-validate-build.
 
@@ -76,7 +94,7 @@
 	hack/release.sh -v $(VERSION) -S "$(GPG_KEYID)"
 
 .PHONY: install
-install: umoci doc
+install: umoci docs
 	install -D -m0755 umoci $(DESTDIR)/$(BINDIR)/umoci
 	-for man in $(MANPAGES); do \
 		filename="$$(basename -- "$$man")"; \
@@ -100,9 +118,8 @@
 	$(DOCKER_RUN) $(UMOCI_IMAGE) make local-validate
 
 .PHONY: local-validate
-local-validate: local-validate-go local-validate-reproducible local-validate-build
-
-# TODO: Remove the special-case ignored system/* warnings.
+local-validate: local-validate-go local-validate-spell local-validate-reproducible local-validate-build
+
 .PHONY: local-validate-go
 local-validate-go:
 	@type gofmt     >/dev/null 2>/dev/null || (echo "ERROR: gofmt not found." && false)
@@ -114,6 +131,12 @@
 	@type gosec     >/dev/null 2>/dev/null || (echo "ERROR: gosec not found." && false)
 	test -z "$$(gosec -quiet -exclude=G301,G302,G304 $$GOPATH/$(PROJECT)/... | tee /dev/stderr)"
 	./hack/test-vendor.sh
+
+.PHONY: local-validate-spell
+local-validate-spell:
+	make clean
+	@type misspell  >/dev/null 2>/dev/null || (echo "ERROR: misspell not found." && false)
+	test -z "$$(find . -type f -print0 | xargs -0 misspell | grep -vE '/(vendor|third_party|\.site)/' | tee /dev/stderr)"
 
 # Make sure that our builds are reproducible even if you wait between them and
 # the modified time of the files is different.
@@ -134,18 +157,14 @@
 	env CGO_ENABLED=0 $(GO) build ${STATIC_BUILD_FLAGS} -o /dev/null ${CMD}
 	$(GO) test -run nothing ${DYN_BUILD_FLAGS} $(PROJECT)/...
 
-.PHONY: doc
-doc: umociimage
-	$(DOCKER_RUN) $(UMOCI_IMAGE) make local-doc
-
 MANPAGES_MD := $(wildcard doc/man/*.md)
 MANPAGES    := $(MANPAGES_MD:%.md=%)
 
 doc/man/%.1: doc/man/%.1.md
 	$(GO_MD2MAN) -in $< -out $@
 
-.PHONY: local-doc
-local-doc: $(MANPAGES)
+.PHONY: docs
+docs: $(MANPAGES)
 
 # Used for tests.
 DOCKER_IMAGE :=opensuse/amd64:tumbleweed
@@ -155,14 +174,15 @@
 	docker build -t $(UMOCI_IMAGE) --build-arg DOCKER_IMAGE=$(DOCKER_IMAGE) .
 
 ifndef COVERAGE
-COVERAGE := $(shell mktemp --dry-run umoci.cov.XXXXXX)
+COVERAGE := $(notdir $(shell mktemp -u umoci.cov.XXXXXX))
+export COVERAGE
 endif
 
 .PHONY: test-unit
 test-unit: umociimage
 	touch $(COVERAGE) && chmod a+rw $(COVERAGE)
-	$(DOCKER_RUN) -e COVERAGE=$(COVERAGE) --cap-add=SYS_ADMIN $(UMOCI_IMAGE) make local-test-unit
-	$(DOCKER_RUN) -e COVERAGE=$(COVERAGE) -u 1000:1000 --cap-drop=all $(UMOCI_IMAGE) make local-test-unit
+	$(DOCKER_ROOTPRIV_RUN) -e COVERAGE=$(COVERAGE) $(UMOCI_IMAGE) make local-test-unit
+	$(DOCKER_ROOTLESS_RUN) -e COVERAGE=$(COVERAGE) $(UMOCI_IMAGE) make local-test-unit
 
 .PHONY: local-test-unit
 local-test-unit:
@@ -171,16 +191,25 @@
 .PHONY: test-integration
 test-integration: umociimage
 	touch $(COVERAGE) && chmod a+rw $(COVERAGE)
-	$(DOCKER_RUN) -e COVERAGE=$(COVERAGE) $(UMOCI_IMAGE) make TESTS="${TESTS}" local-test-integration
-	$(DOCKER_RUN) -e COVERAGE=$(COVERAGE) -u 1000:1000 --cap-drop=all $(UMOCI_IMAGE) make TESTS="${TESTS}" local-test-integration
+	$(DOCKER_ROOTPRIV_RUN) -e COVERAGE=$(COVERAGE) $(UMOCI_IMAGE) make local-test-integration
+	$(DOCKER_ROOTLESS_RUN) -e COVERAGE=$(COVERAGE) $(UMOCI_IMAGE) make local-test-integration
 
 .PHONY: local-test-integration
 local-test-integration: umoci.cover
 	TESTS="${TESTS}" COVER=1 hack/test-integration.sh
 
+.PHONY: shell
 shell: umociimage
 	$(DOCKER_RUN) $(UMOCI_IMAGE) bash
 
+.PHONY: root-shell
+root-shell: umociimage
+	$(DOCKER_ROOTPRIV_RUN) $(UMOCI_IMAGE) bash
+
+.PHONY: rootless-shell
+rootless-shell: umociimage
+	$(DOCKER_ROOTLESS_RUN) $(UMOCI_IMAGE) bash
+
 .PHONY: ci
-ci: umoci umoci.cover doc validate test-unit test-integration
+ci: umoci umoci.cover validate docs test-unit test-integration
 	hack/ci-coverage.sh $(COVERAGE)

=== debian/changelog ===
umoci (0.4.6+ds-2) unstable; urgency=medium

  * Team upload.
  * Don't set fake git commit in package version when building

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 03 Feb 2021 02:07:05 +0800

umoci (0.4.6+ds-1) unstable; urgency=medium

  * Team upload.

  [ Dmitry Smirnov ]
  * Updated for new project location/namespace.
  * Rules-Requires-Root: no

  [ Debian Janitor ]
  * Bump debhelper from old 11 to 12.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Submit, Repository-Browse.
  * Remove obsolete field Name from debian/upstream/metadata
  * Update standards version to 4.5.0, no changes needed.

  [ Shengjing Zhu ]
  * Change repacksuffix to +ds
  * New upstream version 0.4.6+ds
  * Refresh Build-Depends and Depends
  * Update maintainer address to team+pkg-go@tracker.debian.org
  * Bump debhelper-compat to 13
  * Add autopkgtest-go
  * Update Standards-Version to 4.5.1 (no changes)

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 03 Feb 2021 01:48:02 +0800

=== debian/control ===
Source: umoci
Section: devel
Priority: optional
Standards-Version: 4.5.1
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Dmitry Smirnov <onlyjob@debian.org>,
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               go-md2man,
               golang-any,
               golang-github-apex-log-dev,
               golang-github-cyphar-filepath-securejoin-dev,
               golang-github-docker-go-units-dev,
               golang-github-klauspost-pgzip-dev,
               golang-github-mohae-deepcopy-dev,
               golang-github-opencontainers-go-digest-dev,
               golang-github-opencontainers-image-spec-dev,
               golang-github-opencontainers-specs-dev,
               golang-github-pkg-errors-dev,
               golang-github-rootless-containers-proto-dev,
               golang-github-urfave-cli-dev,
               golang-github-vbatts-go-mtree-dev,
               golang-golang-x-net-dev,
               golang-golang-x-sys-dev,
               golang-goprotobuf-dev,
Homepage: https://umo.ci
Vcs-Browser: https://salsa.debian.org/go-team/packages/umoci
Vcs-Git: https://salsa.debian.org/go-team/packages/umoci.git
XS-Go-Import-Path: github.com/opencontainers/umoci
Rules-Requires-Root: no
Testsuite: autopkgtest-pkg-go

Package: umoci
Architecture: any
Built-Using: ${misc:Built-Using},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Open Container Images manipulation tool
 umoci creates and modifies Open Container images.
 See the official website (https://umo.ci/) for more accessible
 documentation about how to use umoci.
 .
 umoci intends to be a complete manipulation tool for OCI images
 (https://github.com/opencontainers/image-spec).  In particular, it should
 be seen as a more end-user-focused version of the oci-image-tools provided
 by the OCI (https://github.com/opencontainers/image-tools). The hope is
 that all of this tooling will eventually be merged with the upstream
 repository, so that it is always kept up-to-date by the Open Container
 Initiative community.
 .
 umoci provides tooling that can abstract all of the internals of the OCI
 specification into a single CLI interface.

Package: golang-github-opensuse-umoci-dev
Architecture: all
Depends: golang-github-apex-log-dev,
         golang-github-cyphar-filepath-securejoin-dev,
         golang-github-docker-go-units-dev,
         golang-github-klauspost-pgzip-dev,
         golang-github-opencontainers-go-digest-dev,
         golang-github-opencontainers-image-spec-dev,
         golang-github-opencontainers-specs-dev,
         golang-github-pkg-errors-dev,
         golang-github-rootless-containers-proto-dev,
         golang-github-urfave-cli-dev,
         golang-github-vbatts-go-mtree-dev,
         golang-golang-x-net-dev,
         golang-golang-x-sys-dev,
         golang-goprotobuf-dev,
         ${misc:Depends},
Description: umoci development files
 umoci creates and modifies Open Container images.
 See the official website (https://umo.ci/) for more accessible
 documentation about how to use umoci.
 .
 umoci intends to be a complete manipulation tool for OCI images
 (https://github.com/opencontainers/image-spec).  In particular, it should
 be seen as a more end-user-focused version of the oci-image-tools provided
 by the OCI (https://github.com/opencontainers/image-tools). The hope is
 that all of this tooling will eventually be merged with the upstream
 repository, so that it is always kept up-to-date by the Open Container
 Initiative community.
 .
 This package provides Golang sources for the umoci API.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

GOLDFLAGS += -X main.version=$(DEB_VERSION)

%:
	dh $@ --buildsystem=golang --with=golang

execute_after_dh_auto_build:
	$(MAKE) docs

override_dh_auto_build:
	dh_auto_build -- -ldflags "$(GOLDFLAGS)"

## umoci 0.4.7+ds

=== Makefile ===
--- 
+++ 
@@ -14,11 +14,13 @@
 # limitations under the License.
 
 # Use bash, so that we can do process substitution.
-SHELL = /bin/bash
+SHELL := $(shell which bash)
 
 # Go tools.
 GO ?= go
 GO_MD2MAN ?= go-md2man
+GOOS ?= $(shell go env GOOS)
+GOARCH ?= $(shell go env GOARCH)
 export GO111MODULE=on
 
 # Set up the ... lovely ... GOPATH hacks.
@@ -26,7 +28,7 @@
 CMD := ${PROJECT}/cmd/umoci
 
 # We use Docker because Go is just horrific to deal with.
-UMOCI_IMAGE := umoci_dev
+UMOCI_IMAGE := umoci/ci:latest
 
 # TODO: We should test umoci with all of the security options disabled so that
 #       we can make sure umoci inside containers works fine (all of these
@@ -34,18 +36,22 @@
 #       itself). The AppArmor/SELinux settings are needed because of the
 #       mount-related tests, and the seccomp/systempaths settings are required
 #       for the runc tests for rootless containers.
-# XXX: Ideally we'd use --security-opt systempaths=unconfined, but the version
-#      of Docker in Travis-CI doesn't support that. Bind-mounting the host's
-#      proc into the container is more dangerous but has the same effect on the
-#      in-kernel mnt_too_revealing() checks and works on old Docker.
-DOCKER_RUN          := docker run --rm -it \
-                                  -v ${PWD}:/go/src/${PROJECT} \
-                                  --security-opt seccomp=unconfined \
-                                  --security-opt apparmor=unconfined \
-                                  --security-opt label=disable \
-                                  -v /proc:/tmp/.HOTFIX-stashed-proc
-DOCKER_ROOTPRIV_RUN := $(DOCKER_RUN) --privileged --cap-add=SYS_ADMIN
-DOCKER_ROOTLESS_RUN := $(DOCKER_RUN) -u 1000:1000 --cap-drop=all
+DOCKER_RUN = docker run --rm -v ${PWD}:/go/src/${PROJECT} \
+                        --security-opt apparmor=unconfined \
+                        --security-opt label=disable \
+                        --security-opt seccomp=unconfined \
+                        --security-opt systempaths=unconfined
+
+# We only add the CodeCov environment (and ping codecov) if we're running in
+# Travis, to avoid pinging third-party servers for local builds.
+ifdef TRAVIS
+$(shell echo "WARNING: This make invocation will fetch and run code from https://codecov.io/." >&2)
+DOCKER_RUN += $(shell echo "+ curl -sSL https://codecov.io/env | bash" >&2) \
+              $(shell ./hack/resilient-curl.sh -sSL https://codecov.io/env | bash)
+endif
+
+DOCKER_ROOTPRIV_RUN = $(DOCKER_RUN) --privileged --cap-add=SYS_ADMIN
+DOCKER_ROOTLESS_RUN = $(DOCKER_RUN) -u 1000:1000 --cap-drop=all
 
 # Output directory.
 BUILD_DIR ?= .
@@ -61,16 +67,23 @@
 # Basic build flags.
 BUILD_FLAGS ?=
 BASE_FLAGS := ${BUILD_FLAGS} -tags "${BUILDTAGS}"
-BASE_LDFLAGS := -s -w -X main.gitCommit=${COMMIT} -X main.version=${VERSION}
+BASE_LDFLAGS := -s -w -X ${PROJECT}.gitCommit=${COMMIT} -X ${PROJECT}.version=${VERSION}
 
 # Specific build flags for build type.
-DYN_BUILD_FLAGS := ${BASE_FLAGS} -buildmode=pie -ldflags "${BASE_LDFLAGS}"
-TEST_BUILD_FLAGS := ${BASE_FLAGS} -buildmode=pie -ldflags "${BASE_LDFLAGS} -X ${PROJECT}/pkg/testutils.binaryType=test"
+ifeq ($(GOOS), linux)
+	TEST_BUILD_FLAGS := ${BASE_FLAGS} -buildmode=pie -ldflags "${BASE_LDFLAGS} -X ${PROJECT}/pkg/testutils.binaryType=test"		   DYN_BUILD_FLAGS := ${BASE_FLAGS} -buildmode=pie -ldflags "${BASE_LDFLAGS}"
+	TEST_BUILD_FLAGS := ${BASE_FLAGS} -buildmode=pie -ldflags "${BASE_LDFLAGS} -X ${PROJECT}/pkg/testutils.binaryType=test"
+else
+	DYN_BUILD_FLAGS := ${BASE_FLAGS} -ldflags "${BASE_LDFLAGS}"
+	TEST_BUILD_FLAGS := ${BASE_FLAGS} -ldflags "${BASE_LDFLAGS} -X ${PROJECT}/pkg/testutils.binaryType=test"
+endif
+
+
 STATIC_BUILD_FLAGS := ${BASE_FLAGS} -ldflags "${BASE_LDFLAGS} -extldflags '-static'"
 
 # Installation directories.
 DESTDIR ?=
-PREFIX ?=/usr
+PREFIX ?=/usr/local
 BINDIR ?=$(PREFIX)/bin
 MANDIR ?=$(PREFIX)/share/man
 
@@ -81,10 +94,13 @@
 # NOTE: If you change these make sure you also update local-validate-build.
 
 umoci: $(GO_SRC)
-	$(GO) build ${DYN_BUILD_FLAGS} -o $(BUILD_DIR)/$@ ${CMD}
+	GOOS=$(GOOS) GOARCH=$(GOARCH) $(GO) build ${DYN_BUILD_FLAGS} -o $(BUILD_DIR)/$@ ${CMD}
 
 umoci.static: $(GO_SRC)
 	env CGO_ENABLED=0 $(GO) build ${STATIC_BUILD_FLAGS} -o $(BUILD_DIR)/$@ ${CMD}
+
+.PHONY: static
+static: umoci.static
 
 umoci.cover: $(GO_SRC)
 	$(GO) test -c -cover -covermode=count -coverpkg=./... ${TEST_BUILD_FLAGS} -o $(BUILD_DIR)/$@ ${CMD}
@@ -110,11 +126,11 @@
 
 .PHONY: clean
 clean:
-	rm -f umoci umoci.static umoci.cov*
+	rm -f umoci umoci.static umoci-ci.tar umoci.cov*
 	rm -f $(MANPAGES)
 
 .PHONY: validate
-validate: umociimage
+validate: ci-image
 	$(DOCKER_RUN) $(UMOCI_IMAGE) make local-validate
 
 .PHONY: local-validate
@@ -167,49 +183,77 @@
 docs: $(MANPAGES)
 
 # Used for tests.
-DOCKER_IMAGE :=opensuse/amd64:tumbleweed
-
-.PHONY: umociimage
-umociimage:
-	docker build -t $(UMOCI_IMAGE) --build-arg DOCKER_IMAGE=$(DOCKER_IMAGE) .
+DOCKER_IMAGE ?=registry.opensuse.org/opensuse/leap:latest
 
 ifndef COVERAGE
 COVERAGE := $(notdir $(shell mktemp -u umoci.cov.XXXXXX))
+endif
 export COVERAGE
-endif
 
 .PHONY: test-unit
-test-unit: umociimage
+test-unit: ci-image
 	touch $(COVERAGE) && chmod a+rw $(COVERAGE)
-	$(DOCKER_ROOTPRIV_RUN) -e COVERAGE=$(COVERAGE) $(UMOCI_IMAGE) make local-test-unit
-	$(DOCKER_ROOTLESS_RUN) -e COVERAGE=$(COVERAGE) $(UMOCI_IMAGE) make local-test-unit
+	$(DOCKER_ROOTPRIV_RUN) -e COVERAGE $(UMOCI_IMAGE) make local-test-unit
+	$(DOCKER_ROOTLESS_RUN) -e COVERAGE $(UMOCI_IMAGE) make local-test-unit
 
 .PHONY: local-test-unit
 local-test-unit:
-	GO=$(GO) COVER=1 hack/test-unit.sh
+	GO=$(GO) hack/test-unit.sh
 
 .PHONY: test-integration
-test-integration: umociimage
+test-integration: ci-image
 	touch $(COVERAGE) && chmod a+rw $(COVERAGE)
-	$(DOCKER_ROOTPRIV_RUN) -e COVERAGE=$(COVERAGE) $(UMOCI_IMAGE) make local-test-integration
-	$(DOCKER_ROOTLESS_RUN) -e COVERAGE=$(COVERAGE) $(UMOCI_IMAGE) make local-test-integration
+	$(DOCKER_ROOTPRIV_RUN) -e COVERAGE -e TESTS $(UMOCI_IMAGE) make local-test-integration
+	$(DOCKER_ROOTLESS_RUN) -e COVERAGE -e TESTS $(UMOCI_IMAGE) make local-test-integration
 
 .PHONY: local-test-integration
 local-test-integration: umoci.cover
-	TESTS="${TESTS}" COVER=1 hack/test-integration.sh
+	TESTS="${TESTS}" hack/test-integration.sh
 
 .PHONY: shell
-shell: umociimage
-	$(DOCKER_RUN) $(UMOCI_IMAGE) bash
+shell: ci-image
+	$(DOCKER_RUN) -it $(UMOCI_IMAGE) bash
 
 .PHONY: root-shell
-root-shell: umociimage
-	$(DOCKER_ROOTPRIV_RUN) $(UMOCI_IMAGE) bash
+root-shell: ci-image
+	$(DOCKER_ROOTPRIV_RUN) -it $(UMOCI_IMAGE) bash
 
 .PHONY: rootless-shell
-rootless-shell: umociimage
-	$(DOCKER_ROOTLESS_RUN) $(UMOCI_IMAGE) bash
+rootless-shell: ci-image
+	$(DOCKER_ROOTLESS_RUN) -it $(UMOCI_IMAGE) bash
+
+CACHE := .cache
+CACHE_IMAGE := $(CACHE)/ci-image.tar.zst
+
+.PHONY: ci-image
+ci-image:
+	docker pull registry.opensuse.org/opensuse/leap:latest
+	! [ -f "$(CACHE_IMAGE)" ] || unzstd < "$(CACHE_IMAGE)" | docker load
+	DOCKER_BUILDKIT=1 docker build -t $(UMOCI_IMAGE) \
+	                               --progress plain \
+	                               --cache-from $(UMOCI_IMAGE) \
+	                               --build-arg DOCKER_IMAGE=$(DOCKER_IMAGE) \
+	                               --build-arg BUILDKIT_INLINE_CACHE=1 .
+
+.PHONY: ci-cache
+ci-cache: ci-image
+	rm -rf $(CACHE) && mkdir -p $(CACHE)
+	docker save $(UMOCI_IMAGE) | zstd > $(CACHE_IMAGE)
+
+.PHONY: ci-validate
+ci-validate: umoci umoci.static
+	make docs local-validate
+
+.PHONY: ci-unit
+ci-unit: umoci.cover
+	make test-unit
+
+.PHONY: ci-integration
+ci-integration: umoci.cover
+	make test-integration
 
 .PHONY: ci
-ci: umoci umoci.cover validate docs test-unit test-integration
+ci:
+	@echo "NOTE: This is not identical to the upstream CI, but the tests are the same."
+	make ci-validate ci-unit ci-integration
 	hack/ci-coverage.sh $(COVERAGE)

=== debian/changelog ===
umoci (0.4.7+ds-3) unstable; urgency=medium

  * Team upload.
  * Fix building with golang-github-rootless-containers-proto 0.1.2
  * Update Standards-Version to 4.6.1 (no changes)
  * Move golang-github-opensuse-umoci-dev to golang section
  * Add Multi-Arch hint

 -- Shengjing Zhu <zhsj@debian.org>  Thu, 08 Sep 2022 23:04:56 +0800

umoci (0.4.7+ds-2) unstable; urgency=medium

  * Team upload.
  * Fix populating version string in d/rules

 -- Shengjing Zhu <zhsj@debian.org>  Tue, 06 Apr 2021 22:51:40 +0800

umoci (0.4.7+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 0.4.7+ds
    CVE-2021-29136: malicious layer with symlink entry for "/" allows
    overwriting of host files

 -- Shengjing Zhu <zhsj@debian.org>  Tue, 06 Apr 2021 22:42:24 +0800

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: umoci
 Section: devel
 Priority: optional
-Standards-Version: 4.5.1
+Standards-Version: 4.6.1
 Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Dmitry Smirnov <onlyjob@debian.org>,
 Build-Depends: debhelper-compat (= 13),
@@ -11,18 +11,20 @@
                golang-github-apex-log-dev,
                golang-github-cyphar-filepath-securejoin-dev,
                golang-github-docker-go-units-dev,
+               golang-github-klauspost-compress-dev,
                golang-github-klauspost-pgzip-dev,
                golang-github-mohae-deepcopy-dev,
                golang-github-opencontainers-go-digest-dev,
                golang-github-opencontainers-image-spec-dev,
+               golang-github-opencontainers-runc-dev,
                golang-github-opencontainers-specs-dev,
                golang-github-pkg-errors-dev,
-               golang-github-rootless-containers-proto-dev,
+               golang-github-rootless-containers-proto-dev (>= 0.1.2~),
+               golang-github-stretchr-testify-dev,
                golang-github-urfave-cli-dev,
                golang-github-vbatts-go-mtree-dev,
-               golang-golang-x-net-dev,
                golang-golang-x-sys-dev,
-               golang-goprotobuf-dev,
+               golang-google-protobuf-dev,
 Homepage: https://umo.ci
 Vcs-Browser: https://salsa.debian.org/go-team/packages/umoci
 Vcs-Git: https://salsa.debian.org/go-team/packages/umoci.git
@@ -52,21 +54,24 @@
  specification into a single CLI interface.
 
 Package: golang-github-opensuse-umoci-dev
+Section: golang
 Architecture: all
+Multi-Arch: foreign
 Depends: golang-github-apex-log-dev,
          golang-github-cyphar-filepath-securejoin-dev,
          golang-github-docker-go-units-dev,
+         golang-github-klauspost-compress-dev,
          golang-github-klauspost-pgzip-dev,
          golang-github-opencontainers-go-digest-dev,
          golang-github-opencontainers-image-spec-dev,
+         golang-github-opencontainers-runc-dev,
          golang-github-opencontainers-specs-dev,
          golang-github-pkg-errors-dev,
-         golang-github-rootless-containers-proto-dev,
+         golang-github-rootless-containers-proto-dev (>= 0.1.2~),
          golang-github-urfave-cli-dev,
          golang-github-vbatts-go-mtree-dev,
-         golang-golang-x-net-dev,
          golang-golang-x-sys-dev,
-         golang-goprotobuf-dev,
+         golang-google-protobuf-dev,
          ${misc:Depends},
 Description: umoci development files
  umoci creates and modifies Open Container images.

=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 include /usr/share/dpkg/default.mk
 
-GOLDFLAGS += -X main.version=$(DEB_VERSION)
+GOLDFLAGS += -X github.com/opencontainers/umoci.version=$(DEB_VERSION)
 
 %:
 	dh $@ --buildsystem=golang --with=golang
